<template>
  <div>
    <v-container>
      <v-row>
        <v-col
          cols="2"
          class="pa-0 mr-5"
        >
          <v-expansion-panels
            v-model="searchPanelExpansion"
            multiple
            elevation="0"
            flat
          >
            <!-- <SidebarExpansionPanel
              title="Authors"
              :items="publicArchiveAuthors"
              item-text="name"
              item-count="count"
              item-value="id"
              :loading="dataStatus.sidebarAuthor.loading"
              @trigger="handleSidebarSearch('author', $event.name)"
            /> -->

            <SidebarExpansionPanel
              title="Publish Dates"
              :items="publicArchivePublishDates"
              item-text="date"
              item-count="count"
              item-value="date"
              :loading="dataStatus.sidebarPublishDates.loading"
              @trigger="handleSidebarSearch('date', $event.date)"
            />

            <!-- <SidebarExpansionPanel
              title="Tags"
              :loading="dataStatus.sidebarTags.loading"
            >
              <v-chip
                v-for="(item, index) in publicArchiveTags"
                :key="index"
                class="ma-1 blue lighten-5"
                small
                @click="handleSidebarSearch('tag', item.name)"
                v-text="item.name"
              />
            </SidebarExpansionPanel> -->
          </v-expansion-panels>
        </v-col>

        <v-col>
          <v-row>
            <v-col cols="12">
              <base-searchbar
                title="Advance Search"
                :filter-by="filterList"
                icon="mdi-magnify"
                show-add-filter
                hide-status
                @trigger="$trigger"
                @refresh="bootstrap"
              />

              <div class="archive-container">
                <v-progress-circular
                  v-if="dataStatus.archives.loading"
                  class="d-flex ma-auto mt-10"
                  indeterminate
                  size="70"
                  color="primary"
                />

                <template v-else>
                  <div
                    v-if="!archivesList.length"
                    class="d-flex justify-center text--disabled display-1"
                  >
                    No match
                  </div>

                  <ArchiveCard
                    v-for="(item, key) in archivesList"
                    v-else
                    :key="key"
                    :item="item"
                  />
                </template>
              </div>
            </v-col>
          </v-row>
        </v-col>
      </v-row>
    </v-container>

    <!-- <v-footer app /> -->
  </div>
</template>

<script>
// eslint-disable-next-line no-unused-vars
import { mapActions, mapGetters, mapState } from 'vuex'

import SidebarExpansionPanel from '@/components/PublicArchive/SidebarExpansionPanel'
import ArchiveCard from '@/components/PublicArchive/ArchiveCard'

export default {
  components: {
    SidebarExpansionPanel,
    ArchiveCard
    // VFooter
  },

  data: () => ({
    filterList: [
      { text: 'All', value: 'all' },
      { text: 'Author', value: 'author' },
      { text: 'Year', value: 'year' },
      { text: 'Title', value: 'title' },
      { text: 'Keyword', value: 'tag' }
    ],

    searchPanelExpansion: [0, 1, 2, 3],

    dataStatus: {
      sidebarAuthor: { loading: true },
      sidebarPublishDates: { loading: true },
      sidebarSubjects: { loading: true },
      sidebarTags: { loading: true },
      archives: { loading: true }
    }
  }),

  computed: {
    ...mapState('authors', {
      publicArchiveAuthors: 'publicArchiveAuthors'
    }),

    ...mapState('tags', {
      publicArchiveTags: 'publicArchiveTags'
    }),

    ...mapState('archives', {
      publicArchivePublishDates: 'publicArchivePublishDates',
      archivesList: 'archives'
    })
  },

  watch: {
    $route: {
      async handler (data) {
        await this.bootstrap({ ...data.query })
      },

      immediate: true
    }
  },

  async created () {
    await this.bootstrapSidebar()
  },

  methods: {
    ...mapActions('authors', {
      getPublicArchiveAuthorsList: 'getPublicArchiveAuthorsList'
    }),

    ...mapActions('tags', {
      getPublicArchiveTagsList: 'getPublicArchiveTagsList'
    }),

    ...mapActions('archives', {
      getPublicArchivePublishDatesList: 'getPublicArchivePublishDatesList',
      getArchivesList: 'getArchivesList'
    }),

    handleSidebarSearch (filterBy, q) {
      const query = this.$route.query
      const newQuery = { filterBy, q }
      this.$router.push({ query: { ...query, ...newQuery } })
    },

    async bootstrap (query) {
      this.dataStatus.archives.loading = true
      await this.getArchivesList({ ...this.$route.query, ...query })
      this.dataStatus.archives.loading = false
    },

    async bootstrapSidebar () {
      this.dataStatus.sidebarAuthor.loading = true
      this.dataStatus.sidebarSubjects.loading = true
      this.dataStatus.sidebarTags.loading = true
      this.dataStatus.sidebarPublishDates.loading = true

      await Promise.all([
        // this.getPublicArchiveAuthorsList(),
        this.getPublicArchiveTagsList(),
        this.getPublicArchivePublishDatesList()
      ])

      this.dataStatus.sidebarAuthor.loading = false
      this.dataStatus.sidebarSubjects.loading = false
      this.dataStatus.sidebarTags.loading = false
      this.dataStatus.sidebarPublishDates.loading = false
    }
  }
}
</script>
